VERSION 5.00
Begin VB.Form frmHostsToggle 
   Caption         =   "Form1"
   ClientHeight    =   3480
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   4680
   Icon            =   "HostsToggle.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3480
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Tag             =   "Connected"
   Visible         =   0   'False
   Begin VB.Timer tmrUpdate 
      Interval        =   1000
      Left            =   600
      Top             =   0
   End
   Begin VB.Image imgDisabledIcon 
      Height          =   240
      Left            =   240
      Picture         =   "HostsToggle.frx":0F7A
      Top             =   0
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Image imgEnabledIcon 
      Height          =   240
      Left            =   0
      Picture         =   "HostsToggle.frx":10C4
      Top             =   0
      Visible         =   0   'False
      Width           =   240
   End
End
Attribute VB_Name = "frmHostsToggle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Private Declare Function DestroyMenu Lib "user32" (ByVal hMenu&) As Long

Private Sub Form_Load()
   'Only allow one instance of HostsToggle to run simultaneously
   If App.PrevInstance Then End
   
   Dim strTempData As String
   Dim lngLenTempData As Long
   Dim slength As Long  ' receives length of the string returned
   
   windir = Space$(MAX_PATH)  ' initialize buffer to receive the string
   slength = GetWindowsDirectory(windir, MAX_PATH)  ' read the path of the Windows directory
   windir = Left$(windir, slength)  ' extract the returned string from the buffer
   
   'Determine the version of Windows, and thus where the Hosts file is located
   Dim OSV As OSVERSIONINFO
   OSV.dwOSVersionInfoSize = Len(OSV)
   GetVersionEx OSV
   If OSV.dwPlatformId = 1 Then
      HostsPath = "\"  ' Windows 9x/ME
   Else
      HostsPath = "\system32\drivers\etc\" ' Windows NT/2000/XP
   End If
   
   HostsFile = windir & HostsPath & "hosts"
   HostsOffFile = windir & HostsPath & "hosts.off"
   
   If OSV.dwPlatformId = 2 Then 'Windows NT/2000/XP -- check for adequate NTFS permissions
      'Ideally, this should be performed with the AccessCheck function from ADVAPI32.DLL
      'However, the MSDN library claims that this would be complicated and it would be easier
      'Just to catch the access errors if they happen.  So I did.
      On Error Resume Next
      If Exist(HostsFile) Then
         If (GetAttr(HostsFile) And vbReadOnly) = vbReadOnly Then 'If the Hosts file has a Read-Only attribute
            SetAttr HostsFile, GetAttr(HostsFile) - vbReadOnly 'Temporarily remove the Read-Only attribute
            Open HostsFile For Append As #1
            Close
            SetAttr HostsFile, GetAttr(HostsFile) + vbReadOnly 'Restore the Read-Only attribute
            If Err = 75 Then 'Error: Could not remove Read-Only attribute due to NTFS restrictions
               MsgBox "You must have Write permission to the " & windir & "\system32\drivers\etc\ folder and the Hosts file.", vbCritical
               End
            End If
         Else 'Hosts file exists and is not Read-Only
            Open HostsFile For Append As #1
            Close
            If Err = 75 Then 'Error: Could not open Hosts in Write mode due to NTFS restrictions
               MsgBox "You must have Write permission to the " & windir & "\system32\drivers\etc\ folder and the Hosts file.", vbCritical
               End
            End If
         End If
      Else 'Hosts file doesn't exist--try to create it then delete it
         Open HostsFile For Append As #1
         Close
         Kill HostsFile
         If Err = 75 Or Err = 53 Then 'Error: Could not create (or delete?) Hosts file
            MsgBox "You must have Write permission to the " & windir & "\system32\drivers\etc\ folder.", vbCritical
            End
         End If
      End If
      On Error GoTo 0
   End If
   
   If Exist(HostsFile) Then
      NID.hIcon = imgEnabledIcon
      NID.szTip = "Hosts file enabled." & Chr$(0)
   Else
      NID.hIcon = imgDisabledIcon
      NID.szTip = "Hosts file disabled." & Chr$(0)
   End If
   
   Dim success As Long
   Dim pos As Long
   Dim strResult As String
   
   strResult = Space$(MAX_PATH)

   'Look for a text file in the Windows directory, then determine which
   'executable is associated with .txt
   If Dir(windir & "\*.txt") <> "" Then
      success = FindExecutable(Dir(windir & "\*.txt"), windir & "\", strResult)
   Else
      'No TXT file was found--create a temporary dummy file to determine the TXT association
      Open windir & "\a.txt" For Output As #1
      Close
   
      success = FindExecutable("a.txt", windir & "\", strResult)
      
      'Delete the temporary file
      Kill windir & "\a.txt"
   End If
      
   If success >= ERROR_FILE_SUCCESS Then
      pos = InStr(strResult, Chr$(0))
      If pos Then TextEditor = Left$(strResult, pos - 1)
   End If
         
   'If the TextEditor isn't a valid filename and Notepad is found, then
   If Not Exist(TextEditor) Then
      If Exist(windir & "\NOTEPAD.EXE") Then
         TextEditor = windir & "\NOTEPAD.EXE" 'use Notepad as the default text editor
      Else 'Otherwise, disable the ability to edit the Hosts file
         TextEditor = "Not found"
      End If
   End If
   
   If OSV.dwMajorVersion = 4 And OSV.dwMinorVersion <= 10 And OSV.dwPlatformId = 1 Then 'Windows 9x
      If UCase$(Right$(TextEditor, Len(TextEditor) - InStrRev(TextEditor, "\"))) = "NOTEPAD.EXE" _
         Or TextEditor = "Not found" Then
         'Notepad in Win9x is insufficient for editing large Hosts files.  Use Wordpad.
         lngRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\WORDPAD.EXE", REG_OPTION_RESERVED, KEY_QUERY_VALUE, hRegKey)
         If lngRetVal = ERROR_SUCCESS Then
            'If the Registry entry for Wordpad was found, read the location of Wordpad.exe
            strTempData = Space$(MAX_PATH)
            lngLenTempData = MAX_PATH
            RegQueryValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, lngLenTempData
            RegCloseKey hRegKey
            TextEditor = Left$(strTempData, lngLenTempData - 1)
         End If
      End If
   End If
   
   hProcess = -1 'The text editor has not been launched
   
   'If the filename passed by command line argument has quotation marks, remove them
   Dim CommandLine As String
   If Len(Command$) > 2 Then
      If Left$(Command$, 1) = """" And Right$(Command$, 1) = """" Then
         CommandLine = Mid$(Command$, 2, Len(Command$) - 2)
      Else
         CommandLine = Command$
      End If
         
      If Exist(CommandLine) Then
         'A valid filename was passed as an argument.
         'Replace the Hosts file with that file, then exit
         FileCopy CommandLine, HostsFile
         
         'Compares the file lengths to check if the file copied or not
         'Note: This is not really an accurate way to determine this, but good enough for this purpose
         If FileLen(CommandLine) <> FileLen(HostsFile) Then
            MsgBox "Could not load " & Dir$(CommandLine), vbExclamation
         Else
            MsgBox Dir$(CommandLine) & " was successfully loaded.", vbInformation
         End If
         End
      End If
   End If
   
   'Load settings from Registry: HKCU\Software\HostsToggle
   lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\HostsToggle", REG_OPTION_RESERVED, KEY_QUERY_VALUE, hRegKey)
   If lngRetVal = ERROR_SUCCESS Then
      Dim LenLastFilePath As Long
      LastFilePath = Space$(MAX_PATH)
      LenLastFilePath = MAX_PATH
      RegQueryValueEx hRegKey, "HideIconWhileOffline", REG_OPTION_RESERVED, REG_DWORD, LurkMode, 4
      RegQueryValueEx hRegKey, "SafetyTimer", REG_OPTION_RESERVED, REG_DWORD, SafetyIsOn, 4
      RegQueryValueEx hRegKey, "DisableMessages", REG_OPTION_RESERVED, REG_DWORD, SilentMode, 4
      RegQueryValueEx hRegKey, "TimerLength", REG_OPTION_RESERVED, REG_DWORD, TimerLength, 4
      RegQueryValueEx hRegKey, "LastFilePath", REG_OPTION_RESERVED, REG_SZ, ByVal LastFilePath, LenLastFilePath
      LastFilePath = Left$(LastFilePath, LenLastFilePath - 1)
      RegCloseKey hRegKey
      SaveSettings = True 'If HKCU\Software\HostsToggle key exists, that implies that settings should be saved
   End If
   
   'Determine if HostsToggle is already set to start with Windows, and if the current user has privileges to change it
   lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", REG_OPTION_RESERVED, KEY_QUERY_VALUE, hRegKey)
   If lngRetVal = ERROR_SUCCESS Then
      strTempData = Space$(MAX_PATH)
      lngLenTempData = MAX_PATH
      lngRetVal = RegQueryValueEx(hRegKey, "HostsToggle", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, lngLenTempData)
      RegCloseKey hRegKey
      Select Case lngRetVal
      Case ERROR_SUCCESS
         lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
         If lngRetVal = ERROR_SUCCESS Then
            StartWithWindows = 1 'HostsToggle will start with Windows
            RegCloseKey hRegKey
         Else
            StartWithWindows = 3 'HostsToggle will start with Windows; current user can't change the setting
         End If
      Case ERROR_FILE_NOT_FOUND
         lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
         If lngRetVal = ERROR_SUCCESS Then
            StartWithWindows = 0 'HostsToggle won't start with Windows
            RegCloseKey hRegKey
         Else
            StartWithWindows = 2 'HostsToggle won't start with Windows; current user can't change the setting
         End If
      End Select
   Else
      StartWithWindows = 4 'Unabled to determine
   End If
   
   'Determine if *.tgl files are associated with HostsToggle, or some other program
   lngRetVal = RegOpenKeyEx(HKEY_CLASSES_ROOT, ".tgl", REG_OPTION_RESERVED, KEY_QUERY_VALUE, hRegKey)
   If lngRetVal = ERROR_SUCCESS Then
      strTempData = Space$(MAX_PATH)
      lngLenTempData = MAX_PATH
      RegQueryValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, lngLenTempData
      If Left$(strTempData, lngLenTempData - 1) = "HostsFile" Then
         TGLAssociated = 1 'TGL associated with HostsToggle
         'Update the association, in case HostsToggle.exe was moved
         RegCreateKey HKEY_CLASSES_ROOT, "HostsFile", hRegKey
         RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal "HostsToggle File" & vbNullChar, 17
         RegCloseKey hRegKey
         RegCreateKey HKEY_CLASSES_ROOT, "HostsFile\Shell\Open\Command", hRegKey
         strTempData = """" & App.Path & "\" & App.EXEName & ".exe"" %1" & vbNullChar
         RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, Len(strTempData)
         RegCloseKey hRegKey
         RegCreateKey HKEY_CLASSES_ROOT, "HostsFile\DefaultIcon", hRegKey
         strTempData = """" & App.Path & "\" & App.EXEName & ".exe"",0" & vbNullChar
         RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, Len(strTempData)
         RegCloseKey hRegKey
      Else
         TGLAssociated = 2 'TGL associated with a different program
      End If
   Else
      TGLAssociated = 0 'TGL not associated
   End If
   
   If Not IsConnected Then frmHostsToggle.Tag = "Disconnected" 'Default is "Connected"
   If (Not LurkMode) Or IsConnected Then
   
      'add an icon to the system tray. If it
      'is successful (returns true) then subclass
      'to intercept messages
      If ShellTrayAdd Then SubClass frmHostsToggle.hwnd
   End If
End Sub

Private Sub Form_Unload(Cancel As Integer)

  If Not SaveSettings Then RegDeleteKey HKEY_CURRENT_USER, "Software\HostsToggle"
  
  'Remove the icon added to the taskbar
   ShellTrayRemove
   
  'remove subclassing
   UnSubClass
   If m_hPopup Then Call DestroyMenu(m_hPopup)
   If hOptionsMenu Then Call DestroyMenu(hOptionsMenu)

End Sub

Public Function ShellTrayAdd() As Long

  With NID
     .cbSize = LenB(NID)
     .hwnd = frmHostsToggle.hwnd
     .uID = 125&
     .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
     .uCallbackMessage = WM_MYHOOK
      If Exist(HostsFile) Then
         'Hosts file is enabled
         If InStr(NID.szTip, "enabled") = 0 Then
            .hIcon = imgEnabledIcon 'Set system tray icon
            .szTip = "Hosts file enabled." & Chr$(0) 'Set icon ToolTip message
         End If
      Else
         'Hosts file is disabled
         If InStr(NID.szTip, "disabled") = 0 Then
            .hIcon = imgDisabledIcon 'Set system tray icon
            .szTip = "Hosts file disabled." & Chr$(0) 'Set icon ToolTip message
         End If
      End If
   End With

   'Add the icon to the system tray
   ShellTrayAdd = Shell_NotifyIcon(NIM_ADD, NID)

End Function


Private Sub ShellTrayRemove()

  'Remove the icon from the taskbar
   Call Shell_NotifyIcon(NIM_DELETE, NID)
   
End Sub


Private Sub UnSubClass()

  'restore the default message handling
  'before exiting
   If defWindowProc Then
      SetWindowLong frmHostsToggle.hwnd, GWL_WNDPROC, defWindowProc
      defWindowProc = 0
   End If
   
End Sub


Private Sub SubClass(hwnd As Long)

  'assign our own window message
  'procedure (WindowProc)
  
   On Error Resume Next
   defWindowProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WindowProc)
   
End Sub

Private Sub tmrUpdate_Timer()
   'Timer performs maintenance checks:
   '1) Keeps the tray icon up-to-date
   '2) Keeps track of the Internet connection/LurkMode
   '3) Enforces the Hosts "safety timer"
   If Exist(HostsFile) Then
      If InStr(NID.szTip, "enabled") = 0 Then
         'The status of the Hosts file has changed.  Modify the tray icon
         NID.hIcon = imgEnabledIcon
         NID.szTip = "Hosts file enabled." & Chr$(0)
         x = Shell_NotifyIcon(NIM_MODIFY, NID)
      End If
   Else
      If InStr(NID.szTip, "disabled") = 0 Then
         'The status of the Hosts file has changed.  Modify the tray icon
         NID.hIcon = imgDisabledIcon
         NID.szTip = "Hosts file disabled." & Chr$(0)
         x = Shell_NotifyIcon(NIM_MODIFY, NID)
      End If
   End If
   
   If IsConnected And frmHostsToggle.Tag = "Disconnected" Then
      frmHostsToggle.Tag = "Connected"
      If LurkMode Then
         'add an icon to the system tray. If it
         'is successful (returns true) then subclass
         'to intercept messages
         If ShellTrayAdd Then SubClass frmHostsToggle.hwnd
      End If
   
   ElseIf Not IsConnected And frmHostsToggle.Tag = "Connected" Then
      frmHostsToggle.Tag = "Disconnected"
      If LurkMode Then
         'Remove the icon added to the taskbar
         ShellTrayRemove
   
         'remove subclassing
         UnSubClass
         If m_hPopup Then Call DestroyMenu(m_hPopup)
         If hOptionsMenu Then Call DestroyMenu(hOptionsMenu)
      End If
   End If
   'Initialize the timer if neccessary
   'Note: the Timer is always at the current time while the Hosts is enabled
   If tmrUpdate.Tag = "" Or InStr(NID.szTip, "enabled") > 0 Then tmrUpdate.Tag = Date & " " & Time
   'For Daylight Saving Time end, system clock changes, etc...
   If DateDiff("s", tmrUpdate.Tag, Date & " " & Time) < 0 Then tmrUpdate.Tag = Date & " " & Time
   'Check if the Safety Timer has expired, and if so, re-enable Hosts
   If DateDiff("s", tmrUpdate.Tag, Date & " " & Time) > TimerLength And SafetyIsOn And _
      InStr(NID.szTip, "disabled") > 0 And Exist(HostsOffFile) Then ToggleHosts
      
   'Check to see if the text editor was running.
   If hProcess <> -1 Then
      'If it was, and has been closed, restore the Hosts file attributes
      Dim lngExitCode As Long
      Call GetExitCodeProcess(hProcess, lngExitCode)
      DoEvents 'Continue processing
      If lngExitCode <> STATUS_PENDING Then
         hProcess = -1
         If Exist(HostsOffFile) Then
            SetAttr HostsOffFile, HostsAttributes
         Else
            SetAttr HostsFile, HostsAttributes
         End If
      End If
   End If
End Sub
