Attribute VB_Name = "mdlMisc"
Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long              '  1=Win9x, 2=WinNT
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Public Declare Function GetWindowsDirectory Lib "kernel32.dll" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Declare Function InternetGetConnectedState Lib "wininet.dll" (ByRef lpSFlags As Long, ByVal dwReserved As Long) As Long
Public Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal strResult As String) As Long
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Public windir As String    'Windows directory ie. C:\Windows
Public HostsPath As String 'Subdirectory of windir where Hosts is located ie. \System32\Drivers\Etc\
Public HostsFile As String 'Full path of the Hosts file ie. C:\Windows\System32\Drivers\Etc\Hosts
Public HostsOffFile As String 'Almost the same as HostsFile ie. C:\Windows\System32\Drivers\Etc\Hosts.off
Public TextEditor As String 'Path to the executable associated with TXT files
Public LastFilePath As String 'Path last used to load/backup the Hosts file

Public HostsAttributes As Long 'Stores the attributes of the Hosts file while it is being edited
Public SafetyIsOn As Long  'Indicates whether or not Hosts is auto re-activated
Public SilentMode As Long  'Indicates that error messages etc. are disabled
Public LurkMode As Long    'Indicates that the icon is hidden while offline
Public TimerLength As Long 'Time (in seconds) until the Hosts is auto re-activated
Public SaveSettings As Long 'Indicates that options should be saved in Registry
Public hRegKey As Long      'Handle for reading/writing to the Registry
Public hProcess As Long   'PID for the text editor that edits the Hosts file

Public TGLAssociated As Long '0 = *.tgl not associated
                             '1 = *.tgl associated with HostsToggle
                             '2 = *.tgl associated with some other program
Public StartWithWindows As Long '0 = HostsToggle will not start with Windows
                                '1 = HostsToggle will start with Windows
                                '2 = HostsToggle will not start with Windows--this cannot be changed
                                '3 = HostsToggle will start with Windows--this cannot be changed
                                '4 = Unabled to determine--cannot be changed

Public Const OFN_EXPLORER As Long = &H80000
Public Const OFN_FILEMUSTEXIST As Long = &H1000
Public Const OFN_HIDEREADONLY As Long = &H4
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800

Public Const PROCESS_QUERY_INFORMATION = &H400
Public Const STATUS_PENDING = &H103&

Public Type OPENFILENAME
  nStructSize       As Long
  hWndOwner         As Long
  hInstance         As Long
  sFilter           As String
  sCustomFilter     As String
  nMaxCustFilter    As Long
  nFilterIndex      As Long
  sFile             As String
  nMaxFile          As Long
  sFileTitle        As String
  nMaxTitle         As Long
  sInitialDir       As String
  sDialogTitle      As String
  flags             As Long
  nFileOffset       As Integer
  nFileExtension    As Integer
  sDefFileExt       As String
  nCustData         As Long
  fnHook            As Long
  sTemplateName     As String
End Type

Public OFN As OPENFILENAME

Public Const MAX_PATH As Long = 255
Public Const ERROR_FILE_SUCCESS As Long = 32

Public Function Exist(FileName As String) As Boolean
   Dim lngRetVal As Long
   On Error Resume Next
   lngRetVal = Len(Dir$(FileName))
   If Err Or lngRetVal = 0 Or FileName = "" Then
      Exist = False
   Else
      Exist = True
   End If
End Function

Public Function ToggleHosts()
   'SetForegroundWindow So that you can see the resulting message, if any...
   Dim response As Integer
   SetForegroundWindow frmHostsToggle.hwnd
   If Exist(HostsFile) Then
      If Exist(HostsOffFile) Then
         'Error: Both Exist
         If SilentMode = False Then _
            MsgBox "Both """ & HostsFile & """ file and """ & HostsOffFile & """ exist.  One must be manually deleted before you can toggle the Hosts file.", vbCritical, "Error"
      Else
         'Disable Hosts
         FileCopy HostsFile, HostsOffFile
         SetAttr HostsOffFile, GetAttr(HostsFile) 'Transfer file attributes from Hosts to the disabled Hosts
         SetAttr HostsFile, vbNormal              'Remove all attributes from Hosts
         Kill HostsFile                           'Delete Hosts
               
         If SilentMode = False Then _
            MsgBox "Hosts file disabled.  You may need to re-start your Internet browser for the change to be complete."
         NID.szTip = "Hosts file disabled." & Chr$(0)
         NID.hIcon = frmHostsToggle.imgDisabledIcon
         Shell_NotifyIcon NIM_MODIFY, NID
         frmHostsToggle.tmrUpdate.Tag = Date & " " & Time
      End If
   Else
      If Exist(HostsOffFile) Then
         'Re-enable Hosts
         FileCopy HostsOffFile, HostsFile
         SetAttr HostsFile, GetAttr(HostsOffFile) 'Transfer file attributes from disabled Hosts to Hosts
         SetAttr HostsOffFile, vbNormal           'Remove all attributes from disabled Hosts
         Kill HostsOffFile                        'Delete disabled Hosts
                        
         If SilentMode = False Then _
            MsgBox "Hosts file enabled.  You may need to re-start your Internet browser for the change to be complete."
         NID.szTip = "Hosts file enabled." & Chr$(0)
         NID.hIcon = frmHostsToggle.imgEnabledIcon
         Shell_NotifyIcon NIM_MODIFY, NID
         frmHostsToggle.tmrUpdate.Tag = Date & " " & Time
      Else
         'Error: Neither exists
         If SilentMode = False Then _
            MsgBox "Neither """ & HostsFile & """ nor """ & HostsOffFile & """ exist.  No operation performed.", vbExclamation, "Error"
      End If
   End If
End Function

Public Function LoadFile(FileName As String)
   Dim response As Integer
   If Exist(HostsFile) Then
      'Hosts already exists--load FileName?
      If SilentMode = False Then
         response = MsgBox("Are you sure you want to overwrite the current ""Hosts"" file with """ & FileName & """?", vbYesNo + vbQuestion)
         If response = vbYes Then
            HostsAttributes = GetAttr(HostsFile) 'Remember the Hosts file attributes
            SetAttr HostsFile, vbNormal          'Remove the attributes so Hosts can be overwritten
            FileCopy FileName, HostsFile         'Load the file
            SetAttr HostsFile, HostsAttributes   'Restore the attributes
            MsgBox """" & FileName & """ has been made the active Hosts file."
         End If
      Else
         HostsAttributes = GetAttr(HostsFile) 'Remember the Hosts file attributes
         SetAttr HostsFile, vbNormal          'Remove the attributes so Hosts can be overwritten
         FileCopy FileName, HostsFile         'Load the file
         SetAttr HostsFile, HostsAttributes   'Restore the attributes
      End If
   Else
      If Exist(HostsOffFile) Then
      'Hosts file disabled--don't load
         If SilentMode = False Then _
            MsgBox "The ""Hosts"" file is currently disabled.  You must enable it before you switch archives.", vbExclamation
      Else
         'Neither Hosts nor Hosts.off exist--proceed
         FileCopy FileName, HostsFile
         If SilentMode = False Then _
            MsgBox """" & FileName & """ has been made the active Hosts file."
      End If
   End If
End Function

Public Function IsConnected() As Boolean
   Dim flags As Long
   IsConnected = InternetGetConnectedState(flags, 0&) 'Note: Always returns true if connected to a LAN,
                                                      '      regardless of Internet connection
End Function

Public Function FileOpen() As String

   If LastFilePath = "" Then LastFilePath = App.Path
   With OFN
      .nStructSize = Len(OFN)
      .hWndOwner = frmHostsToggle.hwnd
      .sFilter = "HostsToggle Files (*.tgl)" & vbNullChar & "*.tgl" & vbNullChar & _
                 "Text Files (*.txt)" & vbNullChar & "*.txt" & vbNullChar & _
                 "All Files (*.*)" & vbNullChar & "*.*" & vbNullChar & vbNullChar
      .nFilterIndex = 0
      .sFile = Space$(1024) & vbNullChar & vbNullChar
      .nMaxFile = 1026
      .sDefFileExt = "tgl" & vbNullChar & vbNullChar
      .sFileTitle = vbNullChar & Space$(512) & vbNullChar & vbNullChar
      .nMaxTitle = 515
      .sInitialDir = LastFilePath & vbNullChar & vbNullChar
      .sDialogTitle = "Load Hosts File"
      .flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_EXPLORER
   End With

   GetOpenFileName OFN
   
   'If a file was opened, remember the path
   If OFN.sFile <> Space$(1024) & vbNullChar & vbNullChar Then
      LastFilePath = Left$(OFN.sFile, InStrRev(OFN.sFile, "\"))
      If SaveSettings Then
         lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\HostsToggle", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
         If lngRetVal = ERROR_SUCCESS Then
            RegSetValueEx hRegKey, "LastFilePath", REG_OPTION_RESERVED, REG_SZ, ByVal LastFilePath & vbNullChar, Len(LastFilePath) + 1
            RegCloseKey hRegKey
         End If
      End If
      'Return the filename and path
      FileOpen = Left$(Trim$(Left$(OFN.sFile, Len(OFN.sFile) - 2)), Len(Trim$(Left$(OFN.sFile, Len(OFN.sFile) - 2))) - 1)
      Exit Function
   End If
   FileOpen = "" 'If cancel pressed, return nothing
End Function
Public Function FileSave() As String

   If LastFilePath = "" Then LastFilePath = App.Path
   With OFN
      .nStructSize = Len(OFN)
      .hWndOwner = frmHostsToggle.hwnd
      .sFilter = "HostsToggle Files (*.tgl)" & vbNullChar & "*.tgl" & vbNullChar & _
                 "All Files (*.*)" & vbNullChar & "*.*" & vbNullChar & vbNullChar
      .nFilterIndex = 0
      .sFile = Space$(1024) & vbNullChar & vbNullChar
      .nMaxFile = 1026
      .sDefFileExt = "tgl" & vbNullChar & vbNullChar
      .sFileTitle = vbNullChar & Space$(512) & vbNullChar & vbNullChar
      .nMaxTitle = 515
      .sInitialDir = LastFilePath & vbNullChar & vbNullChar
      .sDialogTitle = "Backup Hosts File"
      .flags = OFN_OVERWRITEPROMPT Or OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_EXPLORER
   End With

   GetSaveFileName OFN
   'If a file was saved, remember the path
   If OFN.sFile <> Space$(1024) & vbNullChar & vbNullChar Then
      LastFilePath = Left$(OFN.sFile, InStrRev(OFN.sFile, "\"))
      If SaveSettings Then
         lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\HostsToggle", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
         If lngRetVal = ERROR_SUCCESS Then
            RegSetValueEx hRegKey, "LastFilePath", REG_OPTION_RESERVED, REG_SZ, ByVal LastFilePath & vbNullChar, Len(LastFilePath) + 1
            RegCloseKey hRegKey
         End If
      End If
      'Return the filename and path
      FileSave = Left$(Trim$(Left$(OFN.sFile, Len(OFN.sFile) - 2)), Len(Trim$(Left$(OFN.sFile, Len(OFN.sFile) - 2))) - 1)
      Exit Function
   End If
   FileSave = "" 'If cancel pressed, return nothing
End Function


