Attribute VB_Name = "mdlSystray"
Option Explicit
' Tray notification definitions
Public Const NIM_ADD As Long = &H0
Public Const NIM_MODIFY As Long = &H1
Public Const NIM_DELETE As Long = &H2
Public Const NIF_ICON As Long = &H2
Public Const NIF_TIP As Long = &H4
Public Const NIF_MESSAGE As Long = &H1

' Mouse Window Messages
Public Const WM_LBUTTONDOWN As Long = &H201
Public Const WM_RBUTTONDOWN As Long = &H204

' Menu flags for Add/Check/EnableMenuItem()
Public Const MF_BYCOMMAND As Long = &H0&
Public Const MF_SEPARATOR As Long = &H800&
Public Const MF_GRAYED As Long = &H1&
Public Const MF_DISABLED As Long = &H2&
Public Const MF_UNCHECKED As Long = &H0&
Public Const MF_CHECKED As Long = &H8&
Public Const MF_STRING As Long = &H0&
Public Const MF_POPUP As Long = &H10&

' Flags for TrackPopupMenu
Public Const TPM_RETURNCMD As Long = &H100&

Type POINTAPI
   x As Long
   y As Long
End Type
  
Type NOTIFYICONDATA
  cbSize As Long
  hwnd As Long
  uID As Long
  uFlags As Long
  uCallbackMessage As Long
  hIcon As Long
  szTip As String * 64
End Type

Public NID As NOTIFYICONDATA
Dim strTempData As String

Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Declare Function CreatePopupMenu Lib "user32" () As Long
Declare Function DestroyMenu Lib "user32" (ByVal hMenu&) As Long
Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu&, ByVal wFlags&, ByVal wIDNewItem&, ByVal lpNewItem$) As Long
Declare Function TrackPopupMenu Lib "user32" (ByVal hMenu&, ByVal wFlags&, ByVal x&, ByVal y&, ByVal nReserved&, ByVal hwnd&, ByVal lpRect&) As Long
Declare Function EnableMenuItem Lib "user32" (ByVal hMenu&, ByVal wIDEnableItem&, ByVal wEnable&) As Long
Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Any) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Dim m_hPopup As Long

'defWindowProc: Variable to hold the ID of the
'               default window message processing
'               procedure. Returned by SetWindowLong.
Public defWindowProc As Long

'isSubclassed: flag indicating that subclassing
'              has been done. Provides the means
'              to call the correct message-handler.
Public isSubclassed As Boolean

'Get/SetWindowLong messages
Public Const GWL_WNDPROC As Long = (-4)

'general windows messages
Public Const WM_USER As Long = &H400
Public Const WM_MYHOOK As Long = WM_USER + 1


Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

   'window message procedure
   '
   'If the handle returned is to our form,
   'call a form-specific message handler to
   'deal with the tray notifications.  If it
   'is a general system message, pass it on to
   'the default window procedure.
   '
   'If its ours, we look at lParam for the
   'message generated, and react appropriately.
   On Error Resume Next
  
   Select Case hwnd
   
      'form-specific handler
      Case frmHostsToggle.hwnd
         
         Select Case uMsg
         'check uMsg for the application-defined
         'identifier (NID.uID) assigned to the
         'systray icon in NOTIFYICONDATA (NID).
  
            'WM_MYHOOK was defined as the message sent
            'as the .uCallbackMessage member of
            'NOTIFYICONDATA the systray icon
            Case WM_MYHOOK
            
               'lParam is the value of the message
               'that generated the tray notification.
               Select Case lParam
                  Case WM_LBUTTONDOWN:
                     ToggleHosts
                  Case WM_RBUTTONDOWN:

                     'show the menu
                     Dim pt As POINTAPI
                     Dim lngRetVal As Long
                     Dim hLoadMenu As Long
                     Dim hOptionsMenu As Long
    
                     Const ID_TOGGLE As Long = &H6000
                     Const ID_SEPERATOR As Long = &H6001
                     Const ID_EDIT As Long = &H6002
                     Const ID_LURK As Long = &H6003
                     Const ID_SILENT As Long = &H6004
                     Const ID_SAFETY As Long = &H6005
                     Const ID_EXIT As Long = &H6006
                     Const ID_SAVE As Long = &H6007
                     Const ID_LOAD As Long = &H6008
                     Const ID_BACKUP As Long = &H6009
                     Const ID_ASSOCIATE As Long = &H600A
                     Const ID_AUTOSTART As Long = &H600B
                     
                     ' if the menu already has been created, destroy the old one...
                     If m_hPopup Then
                        DestroyMenu m_hPopup
                     End If
    
                     m_hPopup = CreatePopupMenu()
  
                     ' add an item....
                     If InStr(NID.szTip, "enabled") > 0 Then
                        Call AppendMenu(m_hPopup, MF_STRING, ID_TOGGLE, _
                           ByVal "Disable &Hosts")
                     Else
                        Call AppendMenu(m_hPopup, MF_STRING, ID_TOGGLE, _
                           ByVal "Enable &Hosts")
                        If Not Exist(HostsOffFile) Then
                           'Disable the Enable Hosts menu
                           Call EnableMenuItem(m_hPopup, ID_TOGGLE, _
                              MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED)
                        End If
                     End If
    
                     If Exist(HostsOffFile) And (Not Exist(HostsFile)) Then
                        Call AppendMenu(m_hPopup, MF_STRING, ID_EDIT, _
                           ByVal "&Edit Disabled Hosts")
                     Else
                        Call AppendMenu(m_hPopup, MF_STRING, ID_EDIT, _
                           ByVal "&Edit Hosts")
                     End If
                     
                     If TextEditor = "Not found" Or hProcess <> -1 Then
                        'Disable the Edit Hosts menu if there is no text editor,
                        'Or if the text editor is already running (prevents multiple PIDs)
                        Call EnableMenuItem(m_hPopup, ID_EDIT, _
                           MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED)
                     End If

                     If hLoadMenu Then DestroyMenu (hLoadMenu)
                     Call AppendMenu(m_hPopup, MF_STRING, ID_LOAD, ByVal "&Load Hosts...")
                     If Exist(HostsOffFile) Then
                        'Disable the Load Hosts menu
                        Call EnableMenuItem(m_hPopup, ID_LOAD, _
                           MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED)
                     End If
                     
                     Call AppendMenu(m_hPopup, MF_STRING, ID_BACKUP, ByVal "&Backup Hosts...")
                     If Not Exist(HostsFile) Then
                        'Disable the Backup Hosts menu
                        Call EnableMenuItem(m_hPopup, ID_BACKUP, _
                           MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED)
                     End If
                     
                     Call AppendMenu(m_hPopup, MF_SEPARATOR, ID_SEPERATOR, ByVal vbNullString)
                     hOptionsMenu = CreatePopupMenu()
                     Call AppendMenu(m_hPopup, MF_STRING Or MF_POPUP, hOptionsMenu, ByVal "&Options")
                     Call AppendMenu(m_hPopup, MF_SEPARATOR, ID_SEPERATOR, ByVal vbNullString)
                     Call AppendMenu(m_hPopup, MF_STRING, ID_EXIT, ByVal "E&xit")

                     ' Populate the Options submenu
                     If SaveSettings Then
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_SAVE, ByVal "&Save settings")
                     Else
                        Call AppendMenu(hOptionsMenu, MF_UNCHECKED, ID_SAVE, ByVal "&Save settings")
                     End If
                     
                     Call AppendMenu(hOptionsMenu, MF_SEPARATOR, ID_SEPERATOR, ByVal vbNullString)
                     
                     If LurkMode Then
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_LURK, ByVal "&Hide icon when offline")
                     Else
                        Call AppendMenu(hOptionsMenu, MF_UNCHECKED, ID_LURK, ByVal "&Hide icon when offline")
                     End If
                     
                     If SilentMode Then
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_SILENT, ByVal "&Disable confirmation and error messages")
                     Else
                        Call AppendMenu(hOptionsMenu, MF_UNCHECKED, ID_SILENT, ByVal "&Disable confirmation and error messages")
                     End If
                     
                     If SafetyIsOn Then
                        If TimerLength <> 1 Then
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_SAFETY, ByVal "Auto &re-enable Hosts after " & TimerLength & " seconds")
                        Else
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_SAFETY, ByVal "Auto &re-enable Hosts after 1 second")
                        End If
                     Else
                        Call AppendMenu(hOptionsMenu, MF_UNCHECKED, ID_SAFETY, ByVal "Auto &re-enable Hosts after X seconds...")
                     End If
                     
                     Call AppendMenu(hOptionsMenu, MF_SEPARATOR, ID_SEPERATOR, ByVal vbNullString)
                     
                     If TGLAssociated = 1 Then
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_ASSOCIATE, ByVal "&Associate *.tgl with HostsToggle")
                     Else
                        Call AppendMenu(hOptionsMenu, MF_UNCHECKED, ID_ASSOCIATE, ByVal "&Associate *.tgl with HostsToggle")
                     End If
                     
                     Select Case StartWithWindows
                     Case 1, 3
                        Call AppendMenu(hOptionsMenu, MF_CHECKED, ID_AUTOSTART, ByVal "Start HostsToggle when &Windows starts")
                     Case 0, 2, 4
                        Call AppendMenu(hOptionsMenu, MF_UNCHECKED, ID_AUTOSTART, ByVal "Start HostsToggle when &Windows starts")
                     End Select
                     
                     Select Case StartWithWindows
                     Case 2, 3, 4
                        Call EnableMenuItem(m_hPopup, ID_AUTOSTART, _
                        MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED)
                     End Select

                     ' Store the cursor location in pt.x and pt.y
                     lngRetVal = GetCursorPos(pt)

                     'SetForegroundWindow prevents a bug (particularily in
                     'WinNT) where the popup menu won't disappear if you don't
                     'select something
                     SetForegroundWindow frmHostsToggle.hwnd

                     ' call the api function to display the menu and
                     ' check the return value, which indicates which menu
                     ' item was selected
                     
                     lngRetVal = TrackPopupMenu(m_hPopup, TPM_RETURNCMD, pt.x, pt.y, 0&, hwnd, 0&)
                     Select Case lngRetVal
                        Case ID_TOGGLE
                           ToggleHosts
                        Case ID_EXIT
                           Unload frmHostsToggle
                        Case ID_EDIT
                           Dim ProcessID As Long
                           'Start the text editor.  Capture the PID so that HostsToggle can detect when
                           'the editor is closed.  The Timer will restore the attributes once the file is closed
                           If Exist(HostsOffFile) And (Not Exist(HostsFile)) Then
                              HostsAttributes = GetAttr(HostsOffFile)
                              SetAttr HostsOffFile, vbNormal
                              ProcessID = Shell(TextEditor & " " & HostsOffFile, vbNormalFocus)
                              hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, False, ProcessID)
                           Else
                              HostsAttributes = GetAttr(HostsFile)
                              SetAttr HostsFile, vbNormal
                              ProcessID = Shell(TextEditor & " " & HostsFile, vbNormalFocus)
                              hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, False, ProcessID)
                           End If
                        Case ID_SILENT
                           If SilentMode Then
                              SilentMode = 0
                           Else
                              SilentMode = 1
                              If SaveSettings Then
                                 lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\HostsToggle", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
                                 If lngRetVal = ERROR_SUCCESS Then
                                    RegSetValueEx hRegKey, "DisableMessages", REG_OPTION_RESERVED, REG_DWORD, SilentMode, 4
                                    RegCloseKey hRegKey
                                 End If
                              End If
                           End If

                        Case ID_LURK
                           If LurkMode Then
                              LurkMode = 0
                           Else
                              LurkMode = 1
                              If SaveSettings Then
                                 lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\HostsToggle", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
                                 If lngRetVal = ERROR_SUCCESS Then
                                    RegSetValueEx hRegKey, "HideIconWhileOffline", REG_OPTION_RESERVED, REG_DWORD, LurkMode, 4
                                    RegCloseKey hRegKey
                                 End If
                              End If

                              If Not IsConnected Then
                                 'Remove the icon added to the taskbar
                                 Call Shell_NotifyIcon(NIM_DELETE, NID)

                                 'remove subclassing
                                 If defWindowProc Then
                                     SetWindowLong frmHostsToggle.hwnd, GWL_WNDPROC, defWindowProc
                                     defWindowProc = 0
                                 End If

                                 Call DestroyMenu(m_hPopup)
                                 Call DestroyMenu(hOptionsMenu)
                                 Call DestroyMenu(hLoadMenu)
                              End If
                           End If
                        Case ID_SAFETY
                           frmHostsToggle.tmrUpdate.Tag = Date & " " & Time
                           If SafetyIsOn Then
                              SafetyIsOn = 0
                           Else
                              If TimerLength <= 0 Then TimerLength = 60
                              TimerLength = Val(InputBox("How many seconds until the Hosts file is automatically re-enabled?", "Set Timer", TimerLength))
                              If TimerLength <= 0 Then
                                 TimerLength = 60
                                 If SilentMode = False Then _
                                    MsgBox "Invalid value for timer.", vbExclamation, "Error"
                              Else
                                 SafetyIsOn = 1
                                 If SaveSettings Then
                                 lngRetVal = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\HostsToggle", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey)
                                    If lngRetVal = ERROR_SUCCESS Then
                                       RegSetValueEx hRegKey, "SafetyTimer", REG_OPTION_RESERVED, REG_DWORD, SafetyIsOn, 4
                                       RegSetValueEx hRegKey, "TimerLength", REG_OPTION_RESERVED, REG_DWORD, TimerLength, 4
                                       RegCloseKey hRegKey
                                    End If
                                 End If

                              End If
                           End If
                        Case ID_SAVE
                           If SaveSettings = True Then
                              SaveSettings = False
                           Else
                              SaveSettings = True
                              lngRetVal = RegCreateKey(HKEY_CURRENT_USER, "Software\HostsToggle", hRegKey)
                              If lngRetVal = ERROR_SUCCESS Then
                                 RegSetValueEx hRegKey, "HideIconWhileOffline", REG_OPTION_RESERVED, REG_DWORD, LurkMode, 4
                                 RegSetValueEx hRegKey, "SafetyTimer", REG_OPTION_RESERVED, REG_DWORD, SafetyIsOn, 4
                                 RegSetValueEx hRegKey, "DisableMessages", REG_OPTION_RESERVED, REG_DWORD, SilentMode, 4
                                 RegSetValueEx hRegKey, "TimerLength", REG_OPTION_RESERVED, REG_DWORD, TimerLength, 4
                                 RegSetValueEx hRegKey, "LastFilePath", REG_OPTION_RESERVED, REG_SZ, ByVal LastFilePath & vbNullChar, Len(LastFilePath) + 1
                                 RegCloseKey hRegKey
                              End If
                           End If
                        Case ID_LOAD
                           Dim LoadFileName As String
                           LoadFileName = FileOpen
                           If Exist(LoadFileName) Then LoadFile LoadFileName
                        Case ID_BACKUP
                           Dim SaveFileName As String
                           SaveFileName = FileSave
                           If SaveFileName <> "" Then
                              FileCopy HostsFile, SaveFileName
                              SetAttr SaveFileName, vbArchive
                           End If
                        Case ID_ASSOCIATE
                           Dim response As Long
                           Dim TempFlag As Boolean
                           If TGLAssociated = 1 Then ' Delete the *.tgl association
                            TempFlag = True
                            TGLAssociated = 0
                            RegDeleteKey HKEY_CLASSES_ROOT, ".tgl"
                            RegDeleteKey HKEY_CLASSES_ROOT, "HostsFile\shell\open\command"
                            RegDeleteKey HKEY_CLASSES_ROOT, "HostsFile\shell\open"
                            RegDeleteKey HKEY_CLASSES_ROOT, "HostsFile\shell"
                            RegDeleteKey HKEY_CLASSES_ROOT, "HostsFile"
                           ElseIf TGLAssociated = 2 Then ' *.tgl is taken by another program
                            response = MsgBox("The *.tgl file extension is currently associated with some other program.  Would you like to associate *.tgl with HostsToggle Anyway?", vbYesNo + vbQuestion, "Association already used")
                           End If
                           If TempFlag = False And (TGLAssociated = 0 Or response = vbYes) Then 'Associate *.tgl with HostsToggle
                            TGLAssociated = 1
                            RegCreateKey HKEY_CLASSES_ROOT, ".tgl", hRegKey
                            RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal "HostsFile" & vbNullChar, 10
                            RegCloseKey hRegKey
                            RegCreateKey HKEY_CLASSES_ROOT, "HostsFile", hRegKey
                            RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal "HostsToggle File" & vbNullChar, 17
                            RegCloseKey hRegKey
                            RegCreateKey HKEY_CLASSES_ROOT, "HostsFile\Shell\Open\Command", hRegKey
                            strTempData = """" & App.Path & "\" & App.EXEName & ".exe"" %1" & vbNullChar
                            RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, Len(strTempData)
                            RegCloseKey hRegKey
                            RegCreateKey HKEY_CLASSES_ROOT, "HostsFile\DefaultIcon", hRegKey
                            strTempData = """" & App.Path & "\" & App.EXEName & ".exe"",0" & vbNullChar
                            RegSetValueEx hRegKey, "", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, Len(strTempData)
                            RegCloseKey hRegKey
                           End If
                        Case ID_AUTOSTART
                            Select Case StartWithWindows
                            Case 0
                             StartWithWindows = 1
                             RegOpenKeyEx HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey
                             strTempData = """" & App.Path & "\" & App.EXEName & ".exe""" & vbNullChar
                             RegSetValueEx hRegKey, "HostsToggle", REG_OPTION_RESERVED, REG_SZ, ByVal strTempData, Len(strTempData)
                             RegCloseKey hRegKey
                            Case 1
                             StartWithWindows = 0
                             RegOpenKeyEx HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Run", REG_OPTION_RESERVED, KEY_SET_VALUE, hRegKey
                             RegDeleteValue hRegKey, "HostsToggle"
                             RegCloseKey hRegKey
                            End Select
                    End Select

               End Select
            
           'handle any other form messages by
           'passing to the default message proc
            Case Else
            
               WindowProc = CallWindowProc(defWindowProc, hwnd, uMsg, wParam, lParam)
               Exit Function
         End Select

         'this takes care of messages when the
         'handle specified is not that of the form
      Case Else
      
         WindowProc = CallWindowProc(defWindowProc, hwnd, uMsg, wParam, lParam)
   End Select
   
End Function


